// #####################################################################################
// #                                                                                   #
// #     Beispielprogramm fuer die Klasse Drawing:                                     #
// #                                                                                   #
// #     Programmierer:     Sascha Kurz                                                #
// #     Kontakt:           KurzTEF@web.de					       #
// #     Aktualisierungen:  http://www.stud.uni-bayreuth.de/~a8581/                    #
// #                                                                                   #
// #     getestete Betriebssysteme:       Suse Linux				       #
// #					  DOS					       #
// #     Compiler:                        g++ 2.95.2                                   #
// #     Command:	         	  g++ -O bsp_draw_6.cpp drawing.o  	       #
// #                                                                                   #
// #     letzte Aenderung:                07.07.2001                                   #
// #										       #
// #####################################################################################



#include <iostream>
#include <ctime>
#include "drawing.h"


int main(void)
{
  // Baukastensystem:


  // Berechnet die Anzahl der Polygone eines regelmaessigen n-Ecks,
  // ohne Ausnutzung der Symmetrie, und mit Ausgabe der Rechenzeiten.
  // Gibt zusaetzliche Informationen aus


  Drawing<int, long double>* d;			
  int j,h,h2;
  int s;
  int s2;
  long i,a,rueck;
  time_t TimeGes,TimeDiff,TimeGess;							// Variablen zur Messung der benoetigten Realzeit	

  cout << "Geben Sie die Start-Anzahl der Ecken ein:";
  cin  >> s;
  cout << "Geben Sie die End-Anzahl der Ecken ein:";
  cin  >> s2;
  s2++;
  for(j=s;j<s2;j++)
  {
    d=new Drawing<int,long double>(j);
    time(&TimeGess);									
    time(&TimeGes);
    TimeDiff=TimeGes;
    d->CreateRegularNGon();                                                                // Erzeugt ein regelmaessiges n-Eck
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Anlegen eines regelmaessigen " << j << "-Ecks:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    d->BerechneKreuzungspunkte();								// Berechnet die Kreuzungspunkte	
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Kreuzungspunkte:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    d->sortiereGeradenQS();								// sortiert die Geraden mit Quicksort
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Sortieren der Geraden mit Quicksort";
    if(j>9) cout << " ";
    if(j>99) cout << " ";
    cout << ":   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    if((j%2)==0)
    {
      d->VerschmelzeMehrfachSchnittpunkte();							// Beruecksichtigen von Schnittpunkten aus mehr als zwei Geraden
      time(&TimeGes);
      cout << "Benoetigte Zeit fuer das Verschmelzen                       ";
      if(j>9) cout << " ";
      if(j>99) cout << " ";
      cout << ":   " << TimeGes-TimeDiff << " sec" << endl;
      TimeDiff=TimeGes;
    };
    d->BerechneNachbarArrays();								// Berechnet die Nachbar-Arrays mir einer nicht Speicherplatz optimierten Variante
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Nachbar-Arrays:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    rueck=d->BerechneAnzahlPolygone();							// Berechnet die Anzahl der Polygone mit einer nicht Speicherplatz optimierten Variante
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Anzahl der Polygone:   " << TimeGes-TimeDiff << " sec" << endl;
    time(&TimeDiff);
    cout << "Benoetigte Gesamtzeit:   " << TimeDiff-TimeGess << " sec" << endl;
    cout << endl;

    cout << "Knoten:" << endl;
    cout << "=======" << endl;
    i=d->getAnzahlDerKnoten();
    cout << "Der Graph besitzt " << i << " Knoten, und " << d->getAnzahlDerKanten() << " Kanten." << endl;
    for(h=0;h<i;h++)
      cout << h+1 << ": (" << d->getKnotenX(h) << " , " << d->getKnotenY(h) << ")" << endl;
    for(h=0;h<i-1;h++)
      for(h2=h+1;h2<i;h2++)
        if((d->getMatrix(h,h2))==1)
          cout << "Der Knoten " << h+1 << " ist mit dem Knoten " << h2+1 << " durch eine Kante verbunden." << endl;


    cout << endl;
    cout << "Kreuzungspunkte:" << endl;
    cout << "================" << endl;
    a=d->getAnzahlDerKreuzungspunkte();
    cout << "Das regelmaessige " << j << "-Eck besitzt " << a << " Kreuzungspunkte." << endl;
    for(i=0;i<a;i++)
      cout << i+1 << ": (" << d->getKreuzungspunktX(i) << " , " << d->getKreuzungspunktY(i) << ")" << endl;

    cout << endl;
    cout << "Nachbarn:" << endl;
    cout << "=========" << endl;
    if((j%2)==0)
    {
      cout << "Warnung:" << endl;
      cout << "Da der Graph eine gerade Anzahl von Ecken besitzt, wird die angegebene";
      cout << " Anzahl an Kreuzungspunkten zu hoch sein." << endl;
      cout << "Jeder Kreuzungspunkt, der 0 Nachbarn besitzt wurde verschmolzen." << endl;
    };
    for(h=0;h<d->getAnzahlDerKnoten();h++)
      cout << "Der Knoten " << h+1 << " besitzt " << d->getKnotengrad(h) << " Nachbarn." << endl;
    for(i=0;i<a;i++)
      cout << "Der Kreuzungspunkt " << i+1 << " besitzt " << d->getAnzahlDerNachbarn(i) << " Nachbarn." << endl;
    cout << endl;

    delete d;
  };
  return 0;
};

