// #####################################################################################
// #                                                                                   #
// #     Beispielprogramm fuer die Klasse Drawing:                                     #
// #                                                                                   #
// #     Programmierer:     Sascha Kurz                                                #
// #     Kontakt:           KurzTEF@web.de					       #
// #     Aktualisierungen:  http://www.stud.uni-bayreuth.de/~a8581/                    #
// #                                                                                   #
// #     getestete Betriebssysteme:       Suse Linux				       #
// #		                          DOS					       #	
// #     Compiler:                        g++ 2.95.2                                   #
// #     Command:	         	  g++ -O bsp_draw_8.cpp drawing.o  	       #
// #                                                                                   #
// #     letzte Aenderung:                07.07.2001                                   #
// #										       #
// #####################################################################################



#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include "drawing.h"


int main(void)
{
  // Baukastensystem:


  // Berechnet die Anzahl der Dreiecke eines regelmaessigen n-Ecks,
  // mit Ausnutzung der Symmetrie, und mit Ausgabe der Rechenzeiten.
  // anlegen eines Resultfiles


  Drawing<int, long double>* d;			
  int j;
  int s;
  int s2;
  long rueck;
  char name[100];
  ofstream file;
  time_t TimeGes,TimeDiff,TimeGess;							// Variablen zur Messung der benoetigten Realzeit	

  cout << "Geben Sie den Dateinamen ein, in der die Ergebnisse gespeichert werden sollen:";
  cin  >> name;
  file.open(name,4);									// Daten am Ende einfuegen
  if(file.fail())
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };
  cout << "Geben Sie die Start-Anzahl der Ecken ein:";
  cin  >> s;
  cout << "Geben Sie die End-Anzahl der Ecken ein:";
  cin  >> s2;
  s2++;
  for(j=s;j<s2;j++)
  {
    d=new Drawing<int,long double>(j);
    time(&TimeGess);									
    time(&TimeGes);
    TimeDiff=TimeGes;
    d->CreateRegularNGon();                                                                // Erzeugt ein regelmaessiges n-Eck
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Anlegen eines regelmaessigen " << j << "-Ecks:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    d->BerechneKreuzungspunkte_symmetrisch();								// Berechnet die Kreuzungspunkte	
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Kreuzungspunkte:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    d->sortiereGeradenQS();								// sortiert die Geraden mit Quicksort
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Sortieren der Geraden mit Quicksort";
    if(j>9) cout << " ";
    if(j>99) cout << " ";
    cout << ":   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    if((j%2)==0)
    {
      d->VerschmelzeMehrfachSchnittpunkte();							// Beruecksichtigen von Schnittpunkten aus mehr als zwei Geraden
      time(&TimeGes);
      cout << "Benoetigte Zeit fuer das Verschmelzen                       ";
      if(j>9) cout << " ";
      if(j>99) cout << " ";
      cout << ":   " << TimeGes-TimeDiff << " sec" << endl;
      TimeDiff=TimeGes;
    };
    d->BerechneNachbarArrays_symmetrisch();								// Berechnet die Nachbar-Arrays mir einer nicht Speicherplatz optimierten Variante
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Nachbar-Arrays:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    rueck=d->BerechneAnzahlDreiecke_symmetrisch();							// Berechnet die Anzahl der Dreiecke
    if(rueck<0) rueck=0;
     rueck*=d->getAnzahlDerKnoten();
    if((d->getAnzahlDerKnoten())==3) rueck=1;
    time(&TimeGes);
    cout << "Anzahl der Dreiecke:   " << rueck << endl;

    // Schreiben in Datei
    file << j;
    file << " ";
    file << rueck;
    file << endl;
    if(file.fail())
    {
      cout << "Fehler beim Schreiben des Files." << endl;
      return -1;
    };
    cout << "Benoetigte Zeit fuer das Berechnen der Anzahl der Dreiecke:   " << TimeGes-TimeDiff << " sec" << endl;
    time(&TimeDiff);
    cout << "Benoetigte Gesamtzeit:   " << TimeDiff-TimeGess << " sec" << endl;
    cout << endl;
    delete d;
  };
  file.close();
  return 0;
};

