// #####################################################################################
// #                                                                                   #
// #     Beispielprogramm fuer die Klasse Drawing:                                     #
// #                                                                                   #
// #     Programmierer:     Sascha Kurz                                                #
// #     Kontakt:           KurzTEF@web.de					       #
// #     Aktualisierungen:  http://www.stud.uni-bayreuth.de/~a8581/                    #
// #                                                                                   #
// #     getestete Betriebssysteme:       Suse Linux				       #
// #					  DOS					       #	
// #     Compiler:                        g++ 2.95.2                                   #
// #     Command:	         	  g++ -O bsp_draw_9.cpp drawing.o  	       #
// #                                                                                   #
// #     letzte Aenderung:                07.07.2001                                   #
// #										       #
// #####################################################################################



#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include "drawing.h"


int main(void)
{
  // Baukastensystem:


  // Berechnet die Anzahl der Polygone eines regelmaessigen n-Ecks,
  // ohne Ausnutzung der Symmetrie, und mit Ausgabe der Rechenzeiten.
  // anlegen eines Resultfiles


  Drawing<int, long double>* d;			
  int j,i;
  int s;
  int s2;
  long rueck;
  char name[100];
  ofstream file;
  time_t TimeGes,TimeDiff,TimeGess;							// Variablen zur Messung der benoetigten Realzeit	

  cout << "Geben Sie den Dateinamen ein, in der die Ergebnisse gespeichert werden sollen:";
  cin  >> name;
  file.open(name,4);		
  if(file.fail())
  {
    cout << "Fehler beim Oeffnen des Files." << endl;
    return -1;
  };							// Daten am Ende einfuegen
  cout << "Geben Sie die Start-Anzahl der Ecken ein:";
  cin  >> s;
  cout << "Geben Sie die End-Anzahl der Ecken ein:";
  cin  >> s2;
  s2++;
  for(j=s;j<s2;j++)
  {
    d=new Drawing<int,long double>(j);
    time(&TimeGess);									
    time(&TimeGes);
    TimeDiff=TimeGes;
    d->CreateRegularNGon();                                                                // Erzeugt ein regelmaessiges n-Eck
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Anlegen eines regelmaessigen " << j << "-Ecks:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    d->BerechneKreuzungspunkte();								// Berechnet die Kreuzungspunkte	
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Kreuzungspunkte:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    d->sortiereGeradenQS();								// sortiert die Geraden mit Quicksort
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Sortieren der Geraden mit Quicksort";
    if(j>9) cout << " ";
    if(j>99) cout << " ";
    cout << ":   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    if((j%2)==0)
    {
      d->VerschmelzeMehrfachSchnittpunkte();							// Beruecksichtigen von Schnittpunkten aus mehr als zwei Geraden
      time(&TimeGes);
      cout << "Benoetigte Zeit fuer das Verschmelzen                       ";
      if(j>9) cout << " ";
      if(j>99) cout << " ";
      cout << ":   " << TimeGes-TimeDiff << " sec" << endl;
      TimeDiff=TimeGes;
    };
    d->BerechneNachbarArrays_o1();								// Berechnet die Nachbar-Arrays mir einer Speicherplatz optimierten Variante
    time(&TimeGes);
    cout << "Benoetigte Zeit fuer das Berechnen der Nachbar-Arrays:   " << TimeGes-TimeDiff << " sec" << endl;
    TimeDiff=TimeGes;
    rueck=d->BerechneAnzahlPolygone();							// Berechnet die Anzahl der Polygone
    if(rueck<0) rueck=0;
    // Test auf Korrektheit des Ergebnisses
    int w=-1;
    for(i=3;i<d->getAnzahlDerKnoten();i++)							// Testen des Ergebnisses
      if((d->getPolygone(i)%d->getAnzahlDerKnoten())!=0) w=i;
    if(w==-1)
      cout << "Test OK. Die Anzahl der m-Ecke laesst sich durch die Anzahl der Knoten teilen." << endl;
    else
    {
      cout << "Fehler:" << endl;
      cout << "Die Anzahl der " << w << "-Ecke ist nicht durch " << d->getAnzahlDerKnoten() << " teilbar." << endl;
      char taste;
      cin  >> taste;
      return -1;
    };
    if(rueck==d->AnzahlRegionsRegularPolygon(d->getAnzahlDerKnoten()))			// Testen des Ergebnisses
      cout << "Test OK. Die Gesamtanzahl der Polygone stimmt mit der Formel von Poonen-Rubinstein ueberein." << endl;
    else
    {
      cout << "Fehler:" << endl;
      cout << "Die Gesamtanzahl der Polygone stimmt nicht mit der Formel von Poonen-Rubinstein ueberein." << endl;
      char taste;
      cin  >> taste;
      return -1;
    };
    time(&TimeGes);
    cout << "Anzahl der Polygone:   " << rueck << endl;

    // Schreiben in Datei
    for(i=3;i<=d->getAnzahlDerKnoten();i++)
    {
      file << j;
      file << " ";
      file << i;
      file << " ";
      file << d->getPolygone(i);
      file << endl;
      if(file.fail())
      {
        cout << "Fehler beim Schreiben des Files." << endl;
        return -1;
      };
    };

    cout << "Benoetigte Zeit fuer das Berechnen der Anzahl der Polygone:   " << TimeGes-TimeDiff << " sec" << endl;
    time(&TimeDiff);
    cout << "Benoetigte Gesamtzeit:   " << TimeDiff-TimeGess << " sec" << endl;
    cout << endl;

    delete d;
  };
  file.close();
  return 0;
};

